---
title: Change Heading Levels
product: Form Library
description: SurveyJS utilizes standard HTML elements and attributes to ensure proper document structure. Learn how to use heading levels for survey and form elements within different environments of your JavaScript application.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/change-heading-levels/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Change Heading Levels (Vanilla JS)

A SurveyJS form or survey is rendered using standard HTML elements: `<form>`, `<span>`, `<input>`, etc. To render question, panel, page, and survey titles, the form uses `<div>` elements with specified `role` attributes, which improves accessibility and enables screen readers to identify the elements correctly. As an alternative, survey element titles can be rendered using section headings (`<h1>`-`<h6>`). Headings help you better structure an HTML document and are used by search engines to understand the hierarchy of the web page content. This example demonstrates how to enable them in your survey.

To set form element heading levels, use the [`titleTags`](https://surveyjs.io/form-library/documentation/api-reference/settings#titleTags) object within [global survey settings](https://surveyjs.io/form-library/documentation/api-reference/settings). This object contains a property for each form element that can have a title: `survey`, `page`, `panel`, and `question`. The following code shows how to set these properties:

```js
import { settings } from "survey-core";

settings.titleTags.survey = "h1";
settings.titleTags.page = "h2";
settings.titleTags.panel = "h3";
settings.titleTags.question = "h3";
```

> When specifying section headings, you shouldn't skip levels: always start with `<h1>`, then `<h2>`, and so on. However, a SurveyJS form can be displayed in different environments&mdash;occupy an entire page alone or integrate into another page with its own headings. In each case, the same form elements may have different heading levels to ensure that the HTML document conforms to the standard.

If you want to change heading levels dynamically or based on a condition, handle `SurveyModel`'s [`onGetTitleTagName`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onGetTitleTagName) event. The event's parameters include the form element for which a heading level is being set (`options.element`) and the element's current heading (`options.tagName`). You can change the heading within the event handler. In this demo, the `onGetTitleTagName` event is used to specify a different heading for questions nested in panels. Refer to the component file listing for a code example.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
import { settings } from "survey-core";

settings.titleTags.survey = "h1";
settings.titleTags.page = "h2";
settings.titleTags.panel = "h3";
settings.titleTags.question = "h3";

const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});
survey.onGetTitleTagName.add((_, options) => {
    // Use <h4> instead of <h3> for questions nested in panels
    const parent = options.element.parent;
    if (!!parent && parent.isPanel) {
        options.tagName = "h4";
    }
});

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "title": "Survey title (<h1>)",
  "pages": [
    {
      "name": "page1",
      "title": "Page title (<h2>)",
      "elements": [
        {
          "type": "text",
          "name": "firstName",
          "title": "Question title (<h3>)"
        },
        {
          "type": "text",
          "name": "lastName",
          "title": "Question title (<h3>)"
        },
        {
          "type": "panel",
          "name": "panel1",
          "title": "Panel title (<h3>)",
          "elements": [
            {
              "type": "text",
              "name": "city",
              "title": "Question title (<h4>)"
            },
            {
              "type": "text",
              "name": "street",
              "title": "Question title (<h4>)"
            }
          ]
        }
      ]
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/change-heading-levels/angular.md)
- [React](https://surveyjs.io/form-library/examples/change-heading-levels/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/change-heading-levels/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/change-heading-levels/jquery.md)


---
title: Change Heading Levels
product: Form Library
description: SurveyJS utilizes standard HTML elements and attributes to ensure proper document structure. Learn how to use heading levels for survey and form elements within different environments of your JavaScript application.
framework: Angular
source: https://surveyjs.io/form-library/examples/change-heading-levels/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Change Heading Levels (Angular)

A SurveyJS form or survey is rendered using standard HTML elements: `<form>`, `<span>`, `<input>`, etc. To render question, panel, page, and survey titles, the form uses `<div>` elements with specified `role` attributes, which improves accessibility and enables screen readers to identify the elements correctly. As an alternative, survey element titles can be rendered using section headings (`<h1>`-`<h6>`). Headings help you better structure an HTML document and are used by search engines to understand the hierarchy of the web page content. This example demonstrates how to enable them in your survey.

To set form element heading levels, use the [`titleTags`](https://surveyjs.io/form-library/documentation/api-reference/settings#titleTags) object within [global survey settings](https://surveyjs.io/form-library/documentation/api-reference/settings). This object contains a property for each form element that can have a title: `survey`, `page`, `panel`, and `question`. The following code shows how to set these properties:

```js
import { settings } from "survey-core";

settings.titleTags.survey = "h1";
settings.titleTags.page = "h2";
settings.titleTags.panel = "h3";
settings.titleTags.question = "h3";
```

> When specifying section headings, you shouldn't skip levels: always start with `<h1>`, then `<h2>`, and so on. However, a SurveyJS form can be displayed in different environments&mdash;occupy an entire page alone or integrate into another page with its own headings. In each case, the same form elements may have different heading levels to ensure that the HTML document conforms to the standard.

If you want to change heading levels dynamically or based on a condition, handle `SurveyModel`'s [`onGetTitleTagName`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onGetTitleTagName) event. The event's parameters include the form element for which a heading level is being set (`options.element`) and the element's current heading (`options.tagName`). You can change the heading within the event handler. In this demo, the `onGetTitleTagName` event is used to specify a different heading for questions nested in panels. Refer to the component file listing for a code example.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "title": "Survey title (<h1>)",
  "pages": [
    {
      "name": "page1",
      "title": "Page title (<h2>)",
      "elements": [
        {
          "type": "text",
          "name": "firstName",
          "title": "Question title (<h3>)"
        },
        {
          "type": "text",
          "name": "lastName",
          "title": "Question title (<h3>)"
        },
        {
          "type": "panel",
          "name": "panel1",
          "title": "Panel title (<h3>)",
          "elements": [
            {
              "type": "text",
              "name": "city",
              "title": "Question title (<h4>)"
            },
            {
              "type": "text",
              "name": "street",
              "title": "Question title (<h4>)"
            }
          ]
        }
      ]
    }
  ]
};
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";
import { settings } from "survey-core";

settings.titleTags.survey = "h1";
settings.titleTags.page = "h2";
settings.titleTags.panel = "h3";
settings.titleTags.question = "h3";

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.onGetTitleTagName.add((_, options) => {
            // Use <h4> instead of <h3> for questions nested in panels
            const parent = options.element.parent;
            if (!!parent && parent.isPanel) {
                options.tagName = "h4";
            }
        });
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/change-heading-levels/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/change-heading-levels/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/change-heading-levels/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/change-heading-levels/vanillajs.md)


---
title: Change Heading Levels
product: Form Library
description: SurveyJS utilizes standard HTML elements and attributes to ensure proper document structure. Learn how to use heading levels for survey and form elements within different environments of your JavaScript application.
framework: React
source: https://surveyjs.io/form-library/examples/change-heading-levels/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Change Heading Levels (React)

A SurveyJS form or survey is rendered using standard HTML elements: `<form>`, `<span>`, `<input>`, etc. To render question, panel, page, and survey titles, the form uses `<div>` elements with specified `role` attributes, which improves accessibility and enables screen readers to identify the elements correctly. As an alternative, survey element titles can be rendered using section headings (`<h1>`-`<h6>`). Headings help you better structure an HTML document and are used by search engines to understand the hierarchy of the web page content. This example demonstrates how to enable them in your survey.

To set form element heading levels, use the [`titleTags`](https://surveyjs.io/form-library/documentation/api-reference/settings#titleTags) object within [global survey settings](https://surveyjs.io/form-library/documentation/api-reference/settings). This object contains a property for each form element that can have a title: `survey`, `page`, `panel`, and `question`. The following code shows how to set these properties:

```js
import { settings } from "survey-core";

settings.titleTags.survey = "h1";
settings.titleTags.page = "h2";
settings.titleTags.panel = "h3";
settings.titleTags.question = "h3";
```

> When specifying section headings, you shouldn't skip levels: always start with `<h1>`, then `<h2>`, and so on. However, a SurveyJS form can be displayed in different environments&mdash;occupy an entire page alone or integrate into another page with its own headings. In each case, the same form elements may have different heading levels to ensure that the HTML document conforms to the standard.

If you want to change heading levels dynamically or based on a condition, handle `SurveyModel`'s [`onGetTitleTagName`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onGetTitleTagName) event. The event's parameters include the form element for which a heading level is being set (`options.element`) and the element's current heading (`options.tagName`). You can change the heading within the event handler. In this demo, the `onGetTitleTagName` event is used to specify a different heading for questions nested in panels. Refer to the component file listing for a code example.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
import { settings } from "survey-core";

settings.titleTags.survey = "h1";
settings.titleTags.page = "h2";
settings.titleTags.panel = "h3";
settings.titleTags.question = "h3";

function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    survey.onGetTitleTagName.add((_, options) => {
        // Use <h4> instead of <h3> for questions nested in panels
        const parent = options.element.parent;
        if (!!parent && parent.isPanel) {
            options.tagName = "h4";
        }
    });
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "title": "Survey title (<h1>)",
  "pages": [
    {
      "name": "page1",
      "title": "Page title (<h2>)",
      "elements": [
        {
          "type": "text",
          "name": "firstName",
          "title": "Question title (<h3>)"
        },
        {
          "type": "text",
          "name": "lastName",
          "title": "Question title (<h3>)"
        },
        {
          "type": "panel",
          "name": "panel1",
          "title": "Panel title (<h3>)",
          "elements": [
            {
              "type": "text",
              "name": "city",
              "title": "Question title (<h4>)"
            },
            {
              "type": "text",
              "name": "street",
              "title": "Question title (<h4>)"
            }
          ]
        }
      ]
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/change-heading-levels/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/change-heading-levels/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/change-heading-levels/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/change-heading-levels/vanillajs.md)
